---Bei Freigabe und Einbau in Map bitte Erwähnung in Credits angeben. Danke
FixPrices = {};
FixPrices.metadata = {
	interface = " FS15 1.4.2",
	title = " FixPrices",
	notes = " Korrigiert Frucht Preise",
	author = " (by HappyLooser)",
	version = " v0.1 BETA",	
	datum = " 13.02.2016",
	update = " 21.02.2016",
	web = " http://www.minetropolis.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt.",
	"##Orginal Link Freigabe: Freigabe für Mod Mapper wenn entsprechendes Script erwähnt wird"
};

FixPrices.timerUpdate = { 
	id = nil;
	delay = 3600000; --1 hours
	updateDay = 0;
	wait = 0;
	first = true;
	interval = 112500; --1.875 min	--450000 7.5 min --225000 3.75 min etc. <---induvituell anpassen wie oft in einer Stunde zusätzlich die Preise geprüft werden sollen (isInterval muss dann true sein)
	isInterval = false; --interval true dann laut interval werden die Preise zusätzlich noch zwischen zeitlich geprüft
};

local fixPricesFruits = "grass:0.45:0.01:true straw:0.45:0.01:true manure:0.45:0.01:true liquidManure:0.45:0.01:true"; 
--- Fruchtnamen eintragen die Stündlich geprüft werden sollen und den Preis per Liter für default und den maxLowPrice ab wann er wieder hoch gesetzt werden soll anderfalls bei 0 (Fruchtname wie sie in Gigant vorkommen),optional partOfEconomy true/false setzen oder weg lassen, optional addPartOfEconomy
--- Bsp. grass:0.45 <---dann wird der Preis wenn er 0 ist wieder auf 0.45 gesetzt
--- oder grass:0.45:0.25 <----dann wird der Preis wenn er kleiner als 0.25 oder 0 ist wieder auf 0.45 gesetzt
--- oder grass:0.45:0.25:true <----dann wird der Preis wenn er kleiner als 0.25 oder 0 ist wieder auf 0.45 gesetzt und partOfEconomy wird für die Frucht auf true gesetzt
--- oder grass:0.45:0.25:true:true <----dann wird der Preis wenn er kleiner als 0.25 oder 0 ist wieder auf 0.45 gesetzt und partOfEconomy wird für die Frucht auf true gesetzt und addPartOfEconomy wird auf true gesetzt so das der Preis entsprechend vom Spiel auch gespeichert und verarbeitet wird
-----einfügen in ModDesc.xml 
--<extraSourceFiles>
--    <sourceFile filename="FixPrices.lua" />     
--</extraSourceFiles>
-----einfügen in ModDesc.xml

function FixPrices:loadMap(name)
	if g_server ~= nil and g_server then
		print("---loading".. tostring(FixPrices.metadata.title).. tostring(FixPrices.metadata.version).. tostring(FixPrices.metadata.author).. "---")
		FixPrices.timerUpdate.id = addTimer(1, "FixPrices.timerUpdate");
	end;
	g_currentMission.fixPrices = false; --true wenn in map eingebaut wird,ansonsten false oder löschen und der mohV2 übernimmt die Überwachung
	g_currentMission.fixPricesFruits = fixPricesFruits;
end;

function FixPrices:deleteMap()	
	if g_server ~= nil and g_server then
		if FixPrices.timerUpdate.id ~= nil then
			removeTimer(FixPrices.timerUpdate.id);
		end;
	end;
	FixPrices.timerUpdate.first = true;
	FixPrices.timerUpdate.updateDay = 0;
	FixPrices.timerUpdate.wait = 0;	
	FixPrices.timerUpdate.id = nil;
end;

function FixPrices:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FixPrices:keyEvent(unicode, sym, modifier, isDown)
end;

function FixPrices:update(dt)
	if g_server ~= nil and g_server and FixPrices.timerUpdate.first then		
		FixPrices.timerUpdate.first = false;
		FixPrices.timerUpdate.wait = FixPrices:getMilliSecondsToHours(g_currentMission.environment.dayTime, false)*FixPrices.timerUpdate.delay;		
		FixPrices.timerUpdate.updateDay = g_currentMission.environment.currentDay;
		FixPrices:synFruitsHoursUpdate();
	end;
end;

function FixPrices:draw()
end;
addModEventListener(FixPrices);


---funktionen zum prüfen
function timerUpdate(self)	
	if FixPrices.timerUpdate.id == nil or g_currentMission == nil then return;end;
	if FixPrices.timerUpdate.updateDay ~= g_currentMission.environment.currentDay then
		FixPrices.timerUpdate.updateDay = g_currentMission.environment.currentDay;
		FixPrices:synFruitsHoursUpdate();			
	elseif FixPrices.timerUpdate.isInterval then
		FixPrices:synFruitsHoursUpdate();		
	end;
	if FixPrices.timerUpdate.isInterval then
		setTimerTime(FixPrices.timerUpdate.id, FixPrices.timerUpdate.interval);	
	else
		setTimerTime(FixPrices.timerUpdate.id, FixPrices.timerUpdate.delay);
	end;
end;

function FixPrices:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", math.floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", math.floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", math.floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours;end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

function FixPrices:synFruitsHoursUpdate()	
	local fixPricesFruits = "grass:0.0045 straw:0.0045 manure:0.0045 liquidManure:0.0045";
	if string.len(fixPricesFruits) >= 2 then		
		local changeTypeName = Utils.splitString(" ", fixPricesFruits);
		for k,v in pairs(changeTypeName) do
			local typeAndPrice = Utils.splitString(":", v);			
			local desc = Fillable.fillTypeNameToDesc[typeAndPrice[1]];
			if desc ~= nil then				
				local oldHourPrice = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
				if tonumber(oldHourPrice) <= 0 then
					oldHourPrice = typeAndPrice[2];					
				end;
				local oldLiterPrice = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;				
				if tonumber(oldLiterPrice) <= 0 then					
					Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter = oldHourPrice;					
				end;				
			end;
		end;		
	end	
end;
---funktionen zum prüfen